package Data::Array2ArrayMap::SDB;

use 5.005;
use strict;

#require Exporter;
require DynaLoader;
use vars qw($VERSION @ISA);
#use vars qw(@EXPORT @EXPORT_OK %EXPORT_TAGS);
#@ISA = qw(Exporter DynaLoader);
@ISA = qw(DynaLoader); # Data::Array2ArrayMap

use Carp;

$VERSION = '0.17';

#use vars qw/@ISA  %EXPORT_TAGS @EXPORT_OK @EXPORT $VERSION/;
# @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration	use SDB ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.

#%EXPORT_TAGS = ( 'all' => [ qw// ] );
#@EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );
#@EXPORT = qw//;


#require XSLoader;
#XSLoader::load('SDB', $VERSION);

bootstrap Data::Array2ArrayMap::SDB $VERSION;


sub get {
    return wantarray ? @{&get_ref} : &get_ref->[0];
}

sub find {
    confess "find: I will return ARRAY\n" unless (wantarray);
    return @{&find_ref};
}

# Preloaded methods go here.

1;

__END__

=head1 NAME

SDB - Perl extension for fast search in sdb (Static DB) files.

=head1 SYNOPSIS

 use SDB;

 my $sdb = new SDB($sdb_file);

# Data::Array2ArrayMap interface

my @vals = $sdb->get([key1,key2]);
my @vals = $sdb->find([key1,val2]);

# internal interface
 my $type = $sdb -> type($path0_ref);
 my $rlist1_ref = $sdb -> get_ref($path1_ref);
 my $rlist2_ref = $sdb -> find_ref($path2_ref);
 my $rlist3_ref = $sdb -> find_pair($path3_ref);
 my $rlist3_ref = $sdb -> find_pair_by_prefix($path3_ref);

=head1 ABSTRACT

The module is designed for get/search access to sdb-files. 

=head1 DESCRIPTION

To be writen. 

=head2 EXPORT

None by default.

=head1 AUTHOR

Igor Vlasenko E<lt>vlasenko@imath.kiev.uaE<gt>
A. V. Strelets, E<lt>sav@imath.kiev.uaE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright 2004 by A. V. Strelets 
Copyright 2004,2007 Igor Vlasenko 
Copyright 2004,2007 Megakvartal

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself. 

=cut

 
